package de.ozgcloud.admin.organisationseinheit;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import de.ozgcloud.admin.common.GrpcUtil;
import de.ozgcloud.zufi.grpc.organisationseinheit.GrpcGetByOrganisationsEinheitIdRequest;
import de.ozgcloud.zufi.grpc.organisationseinheit.OrganisationsEinheitServiceGrpc.OrganisationsEinheitServiceBlockingStub;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Service
class OrganisationsEinheitRemoteService {

	@GrpcClient(GrpcUtil.ZUFI_MANAGER_GRPC_CLIENT)
	private OrganisationsEinheitServiceBlockingStub serviceStub;

	@Autowired
	private OrganisationsEinheitMapper organisationsEinheitMapper;

	public List<OrganisationsEinheit> getByOrganisationsEinheitId(String organisationsEinheitId) {
		var request = buildGetByOrganisationsEinheitIdRequest(organisationsEinheitId);
		var response = serviceStub.getByOrganisationsEinheitId(request);
		return response.getOrganisationsEinheitenList().stream().map(organisationsEinheitMapper::fromGrpc).toList();
	}

	GrpcGetByOrganisationsEinheitIdRequest buildGetByOrganisationsEinheitIdRequest(String organisationsEinheitId) {
		return GrpcGetByOrganisationsEinheitIdRequest.newBuilder().setOrganisationsEinheitId(organisationsEinheitId).build();
	}

}
