package de.ozgcloud.admin.organisationseinheit;

import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.mongodb.repository.Query;
import org.springframework.data.mongodb.repository.Update;
import org.springframework.stereotype.Repository;

@Repository
interface OrganisationsEinheitRepository extends MongoRepository<OrganisationsEinheit, String> {

	@Query("{'syncResult': {$ne: 'DELETED'}}")
	List<OrganisationsEinheit> findAllNotDeleted();

	@Query("{'syncResult': {$ne: 'DELETED'}, 'parentId': ?0}")
	List<OrganisationsEinheit> findChildren(String parentId);

	@Query("{'syncResult': { $ne: null }, 'keycloakId': ?0}")
	Optional<OrganisationsEinheit> findSyncedByKeycloakId(String keycloakId);

	@Query("{'syncResult': { $ne: null }, 'lastSyncTimestamp': { $lt: ?0 }}")
	@Update("{'$set':  {'syncResult':  'DELETED'}}")
	void setUnsyncedAsDeleted(long lastSyncTimestamp);

	@Query("{'syncResult': null }")
	Stream<OrganisationsEinheit> findAllWithoutSyncResult();
}
