package de.ozgcloud.admin.organisationseinheit;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.*;

import org.springframework.hateoas.EntityModel;
import org.springframework.hateoas.server.RepresentationModelProcessor;
import org.springframework.stereotype.Component;

import de.ozgcloud.admin.Root;

@Component
class OrganisationsEinheitRootProcessor  implements RepresentationModelProcessor<EntityModel<Root>> {

	static final String REL_ORGANISATIONS_EINHEITEN = "organisationsEinheiten";

	@Override
	public EntityModel<Root> process(EntityModel<Root> model) {
		return model.add(linkTo(methodOn(OrganisationsEinheitController.class).getAll()).withRel(REL_ORGANISATIONS_EINHEITEN));
	}
}
