package de.ozgcloud.admin.organisationseinheit;

import java.time.Instant;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import lombok.RequiredArgsConstructor;
import net.javacrumbs.shedlock.spring.annotation.SchedulerLock;

@Component
@RequiredArgsConstructor
class SyncScheduler {

	private final SyncService syncService;

	@SchedulerLock(name = "SyncScheduler_syncOrganisationsEinheitenWithKeycloak", lockAtLeastFor = "PT5M", lockAtMostFor = "PT23H")
	@Scheduled(cron = "${ozgcloud.administration.sync.organisationseinheiten.cron}")
	public void syncOrganisationsEinheitenWithKeycloak() {
		var syncTimestamp = Instant.now().toEpochMilli();
		syncService.syncOrganisationsEinheitenFromKeycloak(syncTimestamp);
		syncService.syncAddedOrganisationsEinheiten(syncTimestamp);
	}
}
