package de.ozgcloud.admin;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.Mockito.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.ArgumentCaptor;
import org.mockito.Captor;
import org.mockito.InjectMocks;
import org.springframework.data.rest.core.config.RepositoryRestConfiguration;
import org.springframework.hateoas.server.LinkRelationProvider;
import org.springframework.hateoas.server.core.DefaultLinkRelationProvider;

class AdministrationRepositoryRestConfigurerTest {

	@InjectMocks
	private AdministrationRepositoryRestConfigurer configurer;

	@Nested
	class TestConfigureRepositoryRestConfiguration {

		@Captor
		private ArgumentCaptor<LinkRelationProvider> linkRelationProviderArgumentCaptor;

		@Test
		void shouldUseDefaultLinkRelationProvider() {
			var configuration = mock(RepositoryRestConfiguration.class);

			configurer.configureRepositoryRestConfiguration(configuration, null);

			verify(configuration).setLinkRelationProvider(linkRelationProviderArgumentCaptor.capture());
			assertThat(linkRelationProviderArgumentCaptor.getValue()).isInstanceOf(DefaultLinkRelationProvider.class);
		}
	}

}